#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef pair<ll, ll> pll;

vector<vector<int>> sus, syn;
vector<bool> visited;
vector<int> subtree;

bool dfs(int node) {
	if (visited[node]) return false;
	visited[node] = true;
	subtree[node] = 1;
	for (int i=0; i<sus[node].size(); i++) {
		int on = sus[node][i];
		if (dfs(on)) {
			syn[node].push_back(on);
			subtree[node] += subtree[on];
		}
	}
	return true;
}

struct Point {
	ll x, y;
	int id;
};

bool operator<(const Point &p1, const Point & p2) {
	return p1.x < p2.x;
}

class Comp {
	ll x, y;
public:
	Comp(Point p) {
		x = p.x;
		y = p.y;
	}
	
	bool operator()(const Point& p1, const Point& p2) {
		ll x1 = p1.x - x, y1 = p1.y - y;
		ll x2 = p2.x - x, y2 = p2.y - y;
		return x1 * y2 - x2 * y1 > 0;
	}
};

int solve(vector<Point> points, int node) {
	Point me = points.back();
	points.pop_back();
	Comp comparator(me);
	sort(points.begin(), points.end(), comparator);
	int index = 0;
	for (int i=0; i<syn[node].size(); i++) {
		int s = syn[node][i];
		vector<Point> part;
		for (int j=0; j<subtree[s]; j++) {
			part.push_back(points[index]);
			index ++;
		}
		int his_id = solve(part, s);
		cout << me.id << " " << his_id << "\n";
	}
	return me.id;
}

int main () {
	ios::sync_with_stdio(false);
	int n;
	cin >> n;
	sus.resize(n);
	for (int i=0; i<n-1; i++) {
		int a, b;
		cin >> a >> b;
		sus[a].push_back(b);
		sus[b].push_back(a);
	}
	syn.resize(n);
	visited = vector<bool>(n, false);
	subtree.resize(n);
	dfs(0);
	vector<Point> points(n);
	for (int i=0; i<n; i++) {
		cin >> points[i].x >> points[i].y;
		points[i].id = i;
	}
	sort(points.begin(), points.end());
	solve(points, 0);
}
