#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

const int height = 50, width = 100000;
vector<int> sef(width * height, -1), subtree(width * height, 1);

int daj_sefa(int a) {
	if (sef[a] == -1) {
		return a;
	}
	return sef[a] = daj_sefa(sef[a]);
}

void join(int a, int b) {
	a = daj_sefa(a);
	b = daj_sefa(b);
	if (a == b) return;
	if (subtree[a] < subtree[b]) swap(a, b);
	sef[b] = a;
	if (subtree[a] == subtree[b]) subtree[a] ++;
}

vector<vector<bool> > water(height, vector<bool>(width, false));

const int dX[4] = {0, 1, 0, -1}, dY[4] = {-1, 0, 1, 0};
void flood(int x, int y) {
	water[y][x] = true;
	for (int smer=0; smer<4; smer++) {
		int nx = x+dX[smer], ny = y + dY[smer];
		if (nx >= 0 && nx < width && ny >= 0 && ny < height && water[ny][nx]) {
			join(y * width + x, ny * width + nx);
		}
	}
}

struct Segtree {
	vector<ll> tree;
	vector<int> start, end;
	int offset;
	
	Segtree(int n) {	
		for (offset=1; offset < n; offset *= 2);
		tree.resize(offset * 2, 0);
		start.resize(offset*2);
		end.resize(offset*2);
		start[1] = 0;
		end[1] = offset;
		for (int i=1; i<offset; i++) {
			int half = (end[i]-start[i]) / 2;
			start[i*2] = start[i];
			start[i*2+1] = start[i] + half;
			end[i*2] = start[i] + half;
			end[i*2+1] = end[i];
		}
	}
	
	void update(int node, ll mask, int a, int b) {
		if (b <= start[node] || a >= end[node]) return;
		if (tree[node] & mask == mask) return;
		if (end[node] == start[node]+1) {
			ll change = mask & (~tree[node]);
			for (ll y=0; y<height; y++) {
				if (change & (1ll << y)) flood(start[node], y);
			}
			tree[node] |= mask;
			return;
		}
		update(node*2, mask, a, b);
		update(node*2+1, mask, a, b);
		tree[node] = tree[node*2] & tree[node*2+1];
	}
	
};

int main () {
	int l;
	scanf("%d", &l);
	Segtree strom(width);
	for (int i=0; i<l; i++) {
		int t, y1, x1, y2, x2;
		scanf("%d %d %d %d %d", &t, &y1, &x1, &y2, &x2);
		y1--;
		y2--;
		x1--;
		x2--;
		if (t == 0) {
			if (y1 > y2) swap(y1, y2);
			if (x1 > x2) swap(x1, x2);
			ll mask = 0;
			for (int y = y1; y <= y2; y++) {
				mask |= (1ll << y);
			}
			strom.update(1, mask, x1, x2+1);
		}
		else {
			for (int y=0; y<10; y++) {
				for (int x=0; x<10; x++) {
					fprintf(stderr, "%c", ".#"[water[y][x]]);
				}
				fprintf(stderr, "\n");
			}
			bool res;
			if (x1 == x2 && y1 == y2) {
				res = water[y1][x1];
			}
			else {
				int s1 = daj_sefa(y1 * width + x1);
				int s2 = daj_sefa(y2 * width + x2);
				res = (s1 == s2);
			}
			if (res) {
				printf("1\n");
			}
			else {
				printf("0\n");
			}
		}
	}
	
}
