#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

vector<string> transpose(vector<string>& old) {
	int n = old.size(), m = old[0].size();
	vector<string> res(m, string(n, ' '));
	for (int y=0; y<n; y++) {
		for (int x=0; x<m; x++) {
			res[x][y] = old[y][x];
		}
	}
	return res;
}

vector<string> rotate(vector<string>& old) {
	int n = old.size(), m = old[0].size();
	vector<string> res(m, string(n, ' '));
	for (int y=0; y<n; y++) {
		for (int x=0; x<m; x++) {
			res[x][n - y - 1] = old[y][x];
		}
	}
	return res;
}

long long solve(vector<string>& grid) {
	int n = grid.size(), m = grid[0].size();
	ll res = 0;
	vector<vector<ll>> dp(n, vector<ll>(m, 0));
	for (int y=1; y<n; y++) {
		for (int x=1; x<m; x++) {
			if (grid[y][x] == grid[y-1][x] && grid[y][x] == grid[y-1][x-1]) {
				dp[y][x] = min(dp[y-1][x], dp[y-1][x-1]) + 1;
				res += dp[y][x];
			}
		}
	}
	return res;
}

void debug(vector<string>& grid) {
	/*for (int y=0; y<grid.size(); y++) {
		cerr << grid[y] << endl;
	}
	cerr << solve(grid) << endl;*/
}

int main () {
	ios::sync_with_stdio(false);
	
	int n, m;
	cin >> n >> m;
	vector<string> grid(n);
	for (int i=0; i<n; i++) cin >> grid[i];
	
	ll result = 0;
	debug(grid);
	result += solve(grid);
	grid = transpose(grid);
	
	debug(grid);
	result += solve(grid);
	grid = rotate(grid);
	
	debug(grid);
	result += solve(grid);
	grid = transpose(grid);
	
	debug(grid);
	result += solve(grid);
	cout << result << endl;
}
